## haproxy 1.8.19

=== Makefile ===
# This GNU Makefile supports different OS and CPU combinations.
#
# You should use it this way :
#   [g]make TARGET=os ARCH=arch CPU=cpu USE_xxx=1 ...
#
# Valid USE_* options are the following. Most of them are automatically set by
# the TARGET, others have to be explictly specified :
#   USE_DLMALLOC         : enable use of dlmalloc (see DLMALLOC_SRC)
#   USE_EPOLL            : enable epoll() on Linux 2.6. Automatic.
#   USE_KQUEUE           : enable kqueue() on BSD. Automatic.
#   USE_MY_EPOLL         : redefine epoll_* syscalls. Automatic.
#   USE_MY_SPLICE        : redefine the splice syscall if build fails without.
#   USE_NETFILTER        : enable netfilter on Linux. Automatic.
#   USE_PCRE             : enable use of libpcre for regex. Recommended.
#   USE_PCRE_JIT         : enable JIT for faster regex on libpcre >= 8.32
#   USE_PCRE2            : enable use of libpcre2 for regex.
#   USE_PCRE2_JIT        : enable JIT for faster regex on libpcre2
#   USE_POLL             : enable poll(). Automatic.
#   USE_PRIVATE_CACHE    : disable shared memory cache of ssl sessions.
#   USE_THREAD           : enable threads support.
#   USE_PTHREAD_PSHARED  : enable pthread process shared mutex on sslcache.
#   USE_REGPARM          : enable regparm optimization. Recommended on x86.
#   USE_STATIC_PCRE      : enable static libpcre. Recommended.
#   USE_STATIC_PCRE2     : enable static libpcre2.
#   USE_TPROXY           : enable transparent proxy. Automatic.
#   USE_LINUX_TPROXY     : enable full transparent proxy. Automatic.
#   USE_LINUX_SPLICE     : enable kernel 2.6 splicing. Automatic.
#   USE_LIBCRYPT         : enable crypted passwords using -lcrypt
#   USE_CRYPT_H          : set it if your system requires including crypt.h
#   USE_VSYSCALL         : enable vsyscall on Linux x86, bypassing libc
#   USE_GETADDRINFO      : use getaddrinfo() to resolve IPv6 host names.
#   USE_OPENSSL          : enable use of OpenSSL. Recommended, but see below.
#   USE_LUA              : enable Lua support.
#   USE_FUTEX            : enable use of futex on kernel 2.6. Automatic.
#   USE_ACCEPT4          : enable use of accept4() on linux. Automatic.
#   USE_MY_ACCEPT4       : use own implemention of accept4() if glibc < 2.10.
#   USE_ZLIB             : enable zlib library support.
#   USE_SLZ              : enable slz library instead of zlib (pick at most one).
#   USE_CPU_AFFINITY     : enable pinning processes to CPU on Linux. Automatic.
#   USE_TFO              : enable TCP fast open. Supported on Linux >= 3.7.
#   USE_NS               : enable network namespace support. Supported on Linux >= 2.6.24.
#   USE_DL               : enable it if your system requires -ldl. Automatic on Linux.
#   USE_DEVICEATLAS      : enable DeviceAtlas api.
#   USE_51DEGREES        : enable third party device detection library from 51Degrees
#   USE_WURFL            : enable WURFL detection library from Scientiamobile
#   USE_SYSTEMD          : enable sd_notify() support.
#
# Options can be forced by specifying "USE_xxx=1" or can be disabled by using
# "USE_xxx=" (empty string).
#
# Variables useful for packagers :
#   CC is set to "gcc" by default and is used for compilation only.
#   LD is set to "gcc" by default and is used for linking only.
#   ARCH may be useful to force build of 32-bit binary on 64-bit systems
#   CFLAGS is automatically set for the specified CPU and may be overridden.
#   LDFLAGS is automatically set to -g and may be overridden.
#   DEP may be cleared to ignore changes to include files during development
#   SMALL_OPTS may be used to specify some options to shrink memory usage.
#   DEBUG may be used to set some internal debugging options.
#   ERR may be set to non-empty to pass -Werror to the compiler
#   ADDINC may be used to complete the include path in the form -Ipath.
#   ADDLIB may be used to complete the library list in the form -Lpath -llib.
#   DEFINE may be used to specify any additional define, which will be reported
#          by "haproxy -vv" in CFLAGS.
#   SILENT_DEFINE may be used to specify other defines which will not be
#     reported by "haproxy -vv".
#   EXTRA   is used to force building or not building some extra tools.
#   DESTDIR is not set by default and is used for installation only.
#           It might be useful to set DESTDIR if you want to install haproxy
#           in a sandbox.
#   PREFIX  is set to "/usr/local" by default and is used for installation only.
#   SBINDIR is set to "$(PREFIX)/sbin" by default and is used for installation
#           only.
#   MANDIR  is set to "$(PREFIX)/share/man" by default and is used for
#           installation only.
#   DOCDIR  is set to "$(PREFIX)/doc/haproxy" by default and is used for
#           installation only.
#
# Other variables :
#   DLMALLOC_SRC   : build with dlmalloc, indicate the location of dlmalloc.c.
#   DLMALLOC_THRES : should match PAGE_SIZE on every platform (default: 4096).
#   PCREDIR        : force the path to libpcre.
#   PCRE_LIB       : force the lib path to libpcre (defaults to $PCREDIR/lib).
#   PCRE_INC       : force the include path to libpcre ($PCREDIR/inc)
#   SSL_LIB        : force the lib path to libssl/libcrypto
#   SSL_INC        : force the include path to libssl/libcrypto
#   LUA_LIB        : force the lib path to lua
#   LUA_INC        : force the include path to lua
#   LUA_LIB_NAME   : force the lib name (or automatically evaluated, by order of
#                                        priority : lua5.3, lua53, lua).
#   IGNOREGIT      : ignore GIT commit versions if set.
#   VERSION        : force haproxy version reporting.
#   SUBVERS        : add a sub-version (eg: platform, model, ...).
#   VERDATE        : force haproxy's release date.

# Function used to detect support of a given option by the compiler.
# Usage: CFLAGS += $(call cc-opt,option). Eg: $(call cc-opt,-fwrapv)
# Note: ensure the referencing variable is assigned using ":=" and not "=" to
#       call it only once.
cc-opt = $(shell set -e; if $(CC) $(1) -E -xc - -o /dev/null </dev/null >&0 2>&0; then echo "$(1)"; fi;)

# same but emits $2 if $1 is not supported
cc-opt-alt = $(shell set -e; if $(CC) $(1) -E -xc - -o /dev/null </dev/null >&0 2>&0; then echo "$(1)"; else echo "$(2)"; fi;)

# Disable a warning when supported by the compiler. Don't put spaces around the
# warning! And don't use cc-opt which doesn't always report an error until
# another one is also returned.
# Usage: CFLAGS += $(call cc-nowarn,warning). Eg: $(call cc-opt,format-truncation)
cc-nowarn = $(shell set -e; if $(CC) -W$(1) -E -xc - -o /dev/null </dev/null >&0 2>&0; then echo "-Wno-$(1)"; fi;)

#### Installation options.
DESTDIR =
PREFIX = /usr/local
SBINDIR = $(PREFIX)/sbin
MANDIR = $(PREFIX)/share/man
DOCDIR = $(PREFIX)/doc/haproxy

#### TARGET system
# Use TARGET=<target_name> to optimize for a specifc target OS among the
# following list (use the default "generic" if uncertain) :
#    generic, linux22, linux24, linux24e, linux26, solaris,
#    freebsd, openbsd, netbsd, cygwin, haiku, custom, aix51, aix52
TARGET =

#### TARGET CPU
# Use CPU=<cpu_name> to optimize for a particular CPU, among the following
# list :
#    generic, native, i586, i686, ultrasparc, custom
CPU = generic

#### Architecture, used when not building for native architecture
# Use ARCH=<arch_name> to force build for a specific architecture. Known
# architectures will lead to "-m32" or "-m64" being added to CFLAGS and
# LDFLAGS. This can be required to build 32-bit binaries on 64-bit targets.
# Currently, only 32, 64, x86_64, i386, i486, i586 and i686 are understood.
ARCH =

#### Toolchain options.
# GCC is normally used both for compiling and linking.
CC = gcc
LD = $(CC)

#### Debug flags (typically "-g").
# Those flags only feed CFLAGS so it is not mandatory to use this form.
DEBUG_CFLAGS = -g

#### Add -Werror when set to non-empty
ERR =

#### Compiler-specific flags that may be used to disable some negative over-
# optimization or to silence some warnings. -fno-strict-aliasing is needed with
# gcc >= 4.4.
# We rely on signed integer wraparound on overflow, however clang think it
# can do whatever it wants since it's an undefined behavior, so use -fwrapv
# to be sure we get the intended behavior.
SPEC_CFLAGS := -fno-strict-aliasing -Wdeclaration-after-statement
SPEC_CFLAGS += $(call cc-opt-alt,-fwrapv,$(call cc-opt,-fno-strict-overflow))
SPEC_CFLAGS += $(call cc-nowarn,format-truncation)
SPEC_CFLAGS += $(call cc-nowarn,address-of-packed-member)
SPEC_CFLAGS += $(call cc-nowarn,null-dereference)
SPEC_CFLAGS += $(call cc-nowarn,unused-label)

#### Memory usage tuning
# If small memory footprint is required, you can reduce the buffer size. There
# are 2 buffers per concurrent session, so 16 kB buffers will eat 32 MB memory
# with 1000 concurrent sessions. Putting it slightly lower than a page size
# will prevent the additional parameters to go beyond a page. 8030 bytes is
# exactly 5.5 TCP segments of 1460 bytes and is generally good. Useful tuning
# macros include :
#    SYSTEM_MAXCONN, BUFSIZE, MAXREWRITE, REQURI_LEN, CAPTURE_LEN.
# Example: SMALL_OPTS = -DBUFSIZE=8030 -DMAXREWRITE=1030 -DSYSTEM_MAXCONN=1024
SMALL_OPTS =

#### Debug settings
# You can enable debugging on specific code parts by setting DEBUG=-DDEBUG_xxx.
# Currently defined DEBUG macros include DEBUG_FULL, DEBUG_MEMORY, DEBUG_FSM,
# DEBUG_HASH, DEBUG_AUTH, DEBUG_SPOE, DEBUG_UAF and DEBUG_THREAD. Please check
# sources for exact meaning or do not use at all.
DEBUG =

#### Trace options
# Use TRACE=1 to trace function calls to file "trace.out" or to stderr if not
# possible.
TRACE =

#### Additional include and library dirs
# Redefine this if you want to add some special PATH to include/libs
ADDINC =
ADDLIB =

#### Specific macro definitions
# Use DEFINE=-Dxxx to set any tunable macro. Anything declared here will appear
# in the build options reported by "haproxy -vv". Use SILENT_DEFINE if you do
# not want to pollute the report with complex defines.
# The following settings might be of interest when SSL is enabled :
#   LISTEN_DEFAULT_CIPHERS is a cipher suite string used to set the default SSL
#           ciphers on "bind" lines instead of using OpenSSL's defaults.
#   CONNECT_DEFAULT_CIPHERS is a cipher suite string used to set the default
#           SSL ciphers on "server" lines instead of using OpenSSL's defaults.
DEFINE =
SILENT_DEFINE =

#### extra programs to build
# Force this to enable building extra programs or to disable them.
# It's automatically appended depending on the targets.
EXTRA =

#### CPU dependant optimizations
# Some CFLAGS are set by default depending on the target CPU. Those flags only
# feed CPU_CFLAGS, which in turn feed CFLAGS, so it is not mandatory to use
# them. You should not have to change these options. Better use CPU_CFLAGS or
# even CFLAGS instead.
CPU_CFLAGS.generic    = -O2
CPU_CFLAGS.native     = -O2 -march=native
CPU_CFLAGS.i586       = -O2 -march=i586
CPU_CFLAGS.i686       = -O2 -march=i686
CPU_CFLAGS.ultrasparc = -O6 -mcpu=v9 -mtune=ultrasparc
CPU_CFLAGS            = $(CPU_CFLAGS.$(CPU))

#### ARCH dependant flags, may be overriden by CPU flags
ARCH_FLAGS.32     = -m32
ARCH_FLAGS.64     = -m64
ARCH_FLAGS.i386   = -m32 -march=i386
ARCH_FLAGS.i486   = -m32 -march=i486
ARCH_FLAGS.i586   = -m32 -march=i586
ARCH_FLAGS.i686   = -m32 -march=i686
ARCH_FLAGS.x86_64 = -m64 -march=x86-64
ARCH_FLAGS        = $(ARCH_FLAGS.$(ARCH))

#### Common CFLAGS
# These CFLAGS contain general optimization options, CPU-specific optimizations
# and debug flags. They may be overridden by some distributions which prefer to
# set all of them at once instead of playing with the CPU and DEBUG variables.
CFLAGS = $(ARCH_FLAGS) $(CPU_CFLAGS) $(DEBUG_CFLAGS) $(SPEC_CFLAGS)

#### Common LDFLAGS
# These LDFLAGS are used as the first "ld" options, regardless of any library
# path or any other option. They may be changed to add any linker-specific
# option at the beginning of the ld command line.

=== debian/changelog ===
haproxy (1.8.19-1ubuntu1) disco; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - d/t/control, d/t/proxy-localhost: simple DEP8 test to actually
      generate traffic through haproxy.
      [Updated to use "service" instead of "systemctl" to match what was
      submitted to Debian.]

 -- Andreas Hasenack <andreas@canonical.com>  Wed, 20 Feb 2019 14:18:15 +0100

haproxy (1.8.19-1) unstable; urgency=medium

  * New upstream version 1.8.19
    - BUG/MEDIUM: spoe: initialization depending on nbthread must be done last
    - BUG/MEDIUM: server: initialize the idle conns list after parsing the
                  config
    - BUG/MAJOR:  spoe: Don't try to get agent config during SPOP healthcheck
    - BUG/MAJOR:  stream: avoid double free on unique_id (Closes: #921981)

 -- Apollon Oikonomopoulos <apoikos@debian.org>  Tue, 12 Feb 2019 10:30:54 +0200

haproxy (1.8.17-1ubuntu1) disco; urgency=medium

  * d/t/control, d/t/proxy-localhost: simple DEP8 test to actually
    generate traffic through haproxy.

 -- Andreas Hasenack <andreas@canonical.com>  Thu, 24 Jan 2019 18:11:39 -0200

=== debian/control ===
Source: haproxy
Section: net
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian HAProxy Maintainers <haproxy@tracker.debian.org>
Uploaders: Apollon Oikonomopoulos <apoikos@debian.org>,
           Prach Pongpanich <prach@debian.org>,
           Vincent Bernat <bernat@debian.org>
Standards-Version: 4.3.0
Build-Depends: debhelper (>= 10),
               libpcre2-dev,
               libssl-dev,
               liblua5.3-dev,
               libsystemd-dev [linux-any],
               python3-sphinx,
               zlib1g-dev
Build-Depends-Indep: python, python-mako
Homepage: http://www.haproxy.org/
Vcs-Git: https://salsa.debian.org/haproxy-team/haproxy.git
Vcs-Browser: https://salsa.debian.org/haproxy-team/haproxy

Package: haproxy
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, lsb-base (>= 3.0-6)
Pre-Depends: dpkg (>= 1.17.14)
Suggests: vim-haproxy, haproxy-doc
Description: fast and reliable load balancing reverse proxy
 HAProxy is a TCP/HTTP reverse proxy which is particularly suited for high
 availability environments. It features connection persistence through HTTP
 cookies, load balancing, header addition, modification, deletion both ways. It
 has request blocking capabilities and provides interface to display server
 status.

Package: haproxy-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}, libjs-bootstrap (<< 4), libjs-jquery,
 ${sphinxdoc:Depends}
Pre-Depends: dpkg (>= 1.17.14)
Description: fast and reliable load balancing reverse proxy (HTML documentation)
 HAProxy is a TCP/HTTP reverse proxy which is particularly suited for high
 availability environments. It features connection persistence through HTTP
 cookies, load balancing, header addition, modification, deletion both ways. It
 has request blocking capabilities and provides interface to display server
 status.
 .
 This package contains the HTML documentation for haproxy.

Package: vim-haproxy
Architecture: all
Depends: ${misc:Depends}
Recommends: vim-addon-manager
Description: syntax highlighting for HAProxy configuration files
 The vim-haproxy package provides filetype detection and syntax highlighting
 for HAProxy configuration files.
 .
 As per the Debian vim policy, installed addons are not activated
 automatically, but the "vim-addon-manager" tool can be used for this purpose.

## haproxy 1.8.19.1

=== contrib/modsecurity/Makefile ===
DESTDIR    =
PREFIX     = /usr/local
BINDIR     = $(PREFIX)/bin

CC ?= gcc
LD = $(CC)

ifeq ($(MODSEC_INC),)
MODSEC_INC := modsecurity-2.9.1/INSTALL/include
endif

ifeq ($(MODSEC_LIB),)
MODSEC_LIB := modsecurity-2.9.1/INSTALL/lib
endif

ifeq ($(APACHE2_INC),)
APACHE2_INC := /usr/include/apache2
endif

ifeq ($(APR_INC),)
APR_INC := /usr/include/apr-1.0
endif

ifeq ($(LIBXML_INC),)
LIBXML_INC := /usr/include/libxml2
endif

ifeq ($(EVENT_LIB),)
EVENT_LIB := -levent
endif

ifeq ($(EVENT_INC),)
EVENT_INC := /usr/include
endif

CFLAGS  += -g -Wall -pthread
INCS += -I../../include -I../../ebtree -I$(MODSEC_INC) -I$(APACHE2_INC) -I$(APR_INC) -I$(LIBXML_INC) -I$(EVENT_INC)
LIBS += -lpthread  $(EVENT_LIB) -levent_pthreads -lcurl -lapr-1 -laprutil-1 -lxml2 -lpcre -lyajl

OBJS = spoa.o modsec_wrapper.o

modsecurity: $(OBJS)
	$(LD) $(LDFLAGS) -o $@ $^ $(MODSEC_LIB)/standalone.a $(LIBS)

install: modsecurity
	install modsecurity $(DESTDIR)$(BINDIR)

clean:
	rm -f modsecurity $(OBJS)

%.o:	%.c
	$(CC) $(CFLAGS) $(INCS) -c -o $@ $<

=== contrib/tcploop/Makefile ===
CC       = gcc
OPTIMIZE = -O2 -g
DEFINE   =
INCLUDE  =
OBJS     = tcploop

tcploop: tcploop.c
	$(CC) $(OPTIMIZE) $(DEFINE) $(INCLUDE) -o $@ $^

clean:
	rm -f $(OBJS) *.[oas] *~

=== debian/changelog ===
haproxy (1.8.19.1-1+security) unstable; urgency=medium

  * update

 -- Debian HAProxy Maintainers <haproxy@tracker.debian.org>  Thu, 01 Apr 2021 21:31:43 +0800

haproxy (1.8.19.1-1+security) buster; urgency=medium

  * Non-maintainer upload.
  * update to 1.8.19-1+deb10u3 and fix CVE-2019-18277

 -- zhouzilong <zhouzilong@uniontech.com>  Thu, 01 Apr 2021 19:36:29 +0800

haproxy (1.8.19-1+deb10u3) buster; urgency=medium

  * d/logrotate.conf: use rsyslog helper instead of SysV init script.
    Closes: #946973.
  * d/patches: reject messages where "chunked" is missing from
    transfer-encoding. CVE-2019-18277.

 -- Vincent Bernat <bernat@debian.org>  Sat, 01 Aug 2020 14:37:46 +0200

haproxy (1.8.19.1-1+dde) unstable; urgency=medium

  * uos sw64 porting

 -- deepin/sw64 team <sunway@deepin.com>  Tue, 23 Feb 2021 09:52:36 +0800

haproxy (1.8.19-1+deb10u2) buster-security; urgency=medium

  * Apply one patch to fix an overflow in HTTP/2 header handling.
    Fix CVE-2020-11100.

 -- Vincent Bernat <bernat@debian.org>  Wed, 01 Apr 2020 12:00:13 +0200

haproxy (1.8.19-1+deb10u1) buster-security; urgency=high

  * Apply two patches around HTTP/2 header validation allowing an attacker
    to use a CRLF inside an HTTP header. Fix CVE-2019-19330.

 -- Vincent Bernat <bernat@debian.org>  Wed, 27 Nov 2019 17:07:57 +0100

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildflags.mk

ifneq ($(shell dpkg-architecture -qDEB_BUILD_ARCH), sw_64)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
endif
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

MAKEARGS=DESTDIR=debian/haproxy \
	 PREFIX=/usr \
	 IGNOREGIT=true \
	 MANDIR=/usr/share/man \
	 DOCDIR=/usr/share/doc/haproxy \
	 USE_PCRE2=1 \
	 USE_PCRE2_JIT=1 \
	 USE_OPENSSL=1 \
	 USE_ZLIB=1 \
	 USE_LUA=1 \
	 USE_GETADDRINFO=1 \
	 LUA_INC=/usr/include/lua5.3

ifeq ($(DEB_HOST_ARCH_OS),linux)
        MAKEARGS+= USE_NS=1 TARGET=linux2628 USE_SYSTEMD=1
else ifeq ($(DEB_HOST_ARCH_OS),kfreebsd)
        MAKEARGS+= TARGET=freebsd
else
	MAKEARGS+= TARGET=generic
endif

ifneq ($(filter amd64 i386,$(DEB_HOST_ARCH_CPU)),)
	MAKEARGS+= USE_REGPARM=1
endif

ifneq ($(filter armel mips mipsel m68k powerpc powerpcspe sh4,$(DEB_HOST_ARCH)),)
	MAKEARGS+= ADDLIB=-latomic
endif

MAKEARGS += DEBUG_CFLAGS="$(CFLAGS) $(CPPFLAGS)"
MAKEARGS += LDFLAGS="$(LDFLAGS)"
MAKEARGS += VERSION="$(DEB_VERSION_UPSTREAM)"
MAKEARGS += SUBVERS="-$(lastword $(subst -, ,$(DEB_VERSION)))"
MAKEARGS += VERDATE="$(shell TZ=UTC date -d "@$(SOURCE_DATE_EPOCH)" "+%Y/%m/%d")"

%:
	dh $@ --with sphinxdoc

override_dh_auto_configure:

override_dh_auto_build-arch:
	make $(MAKEARGS)
	make -C contrib/systemd $(MAKEARGS)
	dh_auto_build -Dcontrib/halog
	$(MAKE) -C doc/lua-api man

override_dh_auto_build-indep:
	# Build the HTML documentation, after patching dconv
	patch -p1 < $(CURDIR)/debian/patches/debianize-dconv.patch
	for doc in intro configuration management; do \
		python -B $(CURDIR)/debian/dconv/haproxy-dconv.py \
			-i $(CURDIR)/doc/$${doc}.txt \
			-o $(CURDIR)/doc/$${doc}.html ;\
	done
	patch -p1 -R < $(CURDIR)/debian/patches/debianize-dconv.patch
	$(MAKE) -C doc/lua-api html

override_dh_auto_clean:
	make -C contrib/systemd clean
	$(MAKE) -C doc/lua-api clean
	dh_auto_clean
	dh_auto_clean -Dcontrib/halog

override_dh_auto_install-arch:
	make $(MAKEARGS) install
	install -m 0644 -D debian/rsyslog.conf debian/haproxy/etc/rsyslog.d/49-haproxy.conf
	install -m 0644 -D debian/logrotate.conf debian/haproxy/etc/logrotate.d/haproxy

override_dh_auto_install-indep:

override_dh_installdocs:
	dh_installdocs -Xsystemd/ -Xhalog/

override_dh_installexamples:
	dh_installexamples -X build.cfg

override_dh_installinit:
	dh_installinit --no-restart-after-upgrade --no-stop-on-upgrade

override_dh_strip:
	dh_strip --dbgsym-migration="haproxy-dbg"

## haproxy 2.0.5

=== Makefile ===
--- 
+++ 
@@ -1,13 +1,21 @@
 # This GNU Makefile supports different OS and CPU combinations.
 #
 # You should use it this way :
-#   [g]make TARGET=os ARCH=arch CPU=cpu USE_xxx=1 ...
-#
-# Valid USE_* options are the following. Most of them are automatically set by
-# the TARGET, others have to be explictly specified :
-#   USE_DLMALLOC         : enable use of dlmalloc (see DLMALLOC_SRC)
+#   [g]make TARGET=os [ARCH=arch] [CPU=cpu] USE_xxx=1 ...
+#
+# When in doubt, invoke help, possibly with a known target :
+#   [g]make help
+#   [g]make help TARGET=linux-glibc
+#
+# By default the detailed commands are hidden for a cleaner output, but you may
+# see them by appending "V=1" to the make command.
+#
+# Valid USE_* options are enumerated in the "use_opts" variable and are listed
+# below. Most of them are automatically set by the TARGET, others have to be
+# explicitly specified :
 #   USE_EPOLL            : enable epoll() on Linux 2.6. Automatic.
 #   USE_KQUEUE           : enable kqueue() on BSD. Automatic.
+#   USE_EVPORTS          : enable event ports on SunOS systems. Automatic.
 #   USE_MY_EPOLL         : redefine epoll_* syscalls. Automatic.
 #   USE_MY_SPLICE        : redefine the splice syscall if build fails without.
 #   USE_NETFILTER        : enable netfilter on Linux. Automatic.
@@ -34,19 +42,24 @@
 #   USE_FUTEX            : enable use of futex on kernel 2.6. Automatic.
 #   USE_ACCEPT4          : enable use of accept4() on linux. Automatic.
 #   USE_MY_ACCEPT4       : use own implemention of accept4() if glibc < 2.10.
+#   USE_PRCTL            : enable use of prctl(). Automatic.
 #   USE_ZLIB             : enable zlib library support.
 #   USE_SLZ              : enable slz library instead of zlib (pick at most one).
 #   USE_CPU_AFFINITY     : enable pinning processes to CPU on Linux. Automatic.
 #   USE_TFO              : enable TCP fast open. Supported on Linux >= 3.7.
 #   USE_NS               : enable network namespace support. Supported on Linux >= 2.6.24.
 #   USE_DL               : enable it if your system requires -ldl. Automatic on Linux.
+#   USE_RT               : enable it if your system requires -lrt. Automatic on Linux.
 #   USE_DEVICEATLAS      : enable DeviceAtlas api.
 #   USE_51DEGREES        : enable third party device detection library from 51Degrees
 #   USE_WURFL            : enable WURFL detection library from Scientiamobile
 #   USE_SYSTEMD          : enable sd_notify() support.
+#   USE_OBSOLETE_LINKER  : use when the linker fails to emit __start_init/__stop_init
+#   USE_THREAD_DUMP      : use the more advanced thread state dump system. Automatic.
 #
 # Options can be forced by specifying "USE_xxx=1" or can be disabled by using
-# "USE_xxx=" (empty string).
+# "USE_xxx=" (empty string). The list of enabled and disabled options for a
+# given TARGET is enumerated at the end of "make help".
 #
 # Variables useful for packagers :
 #   CC is set to "gcc" by default and is used for compilation only.
@@ -77,11 +90,13 @@
 #           installation only.
 #
 # Other variables :
-#   DLMALLOC_SRC   : build with dlmalloc, indicate the location of dlmalloc.c.
-#   DLMALLOC_THRES : should match PAGE_SIZE on every platform (default: 4096).
+#   PCRE_CONFIG    : force the binary path to get pcre config (by default
+#                                                              pcre-config)
 #   PCREDIR        : force the path to libpcre.
 #   PCRE_LIB       : force the lib path to libpcre (defaults to $PCREDIR/lib).
 #   PCRE_INC       : force the include path to libpcre ($PCREDIR/inc)
+#   PCRE2_CONFIG   : force the binary path to get pcre2 config (by default
+#                                                               pcre2-config)
 #   SSL_LIB        : force the lib path to libssl/libcrypto
 #   SSL_INC        : force the include path to libssl/libcrypto
 #   LUA_LIB        : force the lib path to lua
@@ -92,6 +107,14 @@
 #   VERSION        : force haproxy version reporting.
 #   SUBVERS        : add a sub-version (eg: platform, model, ...).
 #   VERDATE        : force haproxy's release date.
+#   VTEST_PROGRAM  : location of the vtest program to run reg-tests.
+
+# verbosity: pass V=1 for verbose shell invocation
+V = 0
+Q = @
+ifeq ($V,1)
+Q=
+endif
 
 # Function used to detect support of a given option by the compiler.
 # Usage: CFLAGS += $(call cc-opt,option). Eg: $(call cc-opt,-fwrapv)
@@ -118,8 +141,8 @@
 #### TARGET system
 # Use TARGET=<target_name> to optimize for a specifc target OS among the
 # following list (use the default "generic" if uncertain) :
-#    generic, linux22, linux24, linux24e, linux26, solaris,
-#    freebsd, openbsd, netbsd, cygwin, haiku, custom, aix51, aix52
+#    linux-glibc, solaris, freebsd, openbsd, netbsd, cygwin,
+#    haiku, aix51, aix52, osx, generic, custom
 TARGET =
 
 #### TARGET CPU
@@ -146,6 +169,10 @@
 
 #### Add -Werror when set to non-empty
 ERR =
+
+#### May be used to force running a specific set of reg-tests
+REG_TEST_FILES =
+REG_TEST_SCRIPT=./scripts/run-regtests.sh
 
 #### Compiler-specific flags that may be used to disable some negative over-
 # optimization or to silence some warnings. -fno-strict-aliasing is needed with
@@ -157,8 +184,21 @@
 SPEC_CFLAGS += $(call cc-opt-alt,-fwrapv,$(call cc-opt,-fno-strict-overflow))
 SPEC_CFLAGS += $(call cc-nowarn,format-truncation)
 SPEC_CFLAGS += $(call cc-nowarn,address-of-packed-member)
-SPEC_CFLAGS += $(call cc-nowarn,null-dereference)
 SPEC_CFLAGS += $(call cc-nowarn,unused-label)
+SPEC_CFLAGS += $(call cc-nowarn,sign-compare)
+SPEC_CFLAGS += $(call cc-nowarn,unused-parameter)
+SPEC_CFLAGS += $(call cc-nowarn,old-style-declaration)
+SPEC_CFLAGS += $(call cc-nowarn,ignored-qualifiers)
+SPEC_CFLAGS += $(call cc-nowarn,clobbered)
+SPEC_CFLAGS += $(call cc-nowarn,missing-field-initializers)
+SPEC_CFLAGS += $(call cc-nowarn,implicit-fallthrough)
+SPEC_CFLAGS += $(call cc-nowarn,stringop-overflow)
+SPEC_CFLAGS += $(call cc-nowarn,cast-function-type)
+SPEC_CFLAGS += $(call cc-opt,-Wtype-limits)
+SPEC_CFLAGS += $(call cc-opt,-Wshift-negative-value)
+SPEC_CFLAGS += $(call cc-opt,-Wshift-overflow=2)
+SPEC_CFLAGS += $(call cc-opt,-Wduplicated-cond)
+SPEC_CFLAGS += $(call cc-opt,-Wnull-dereference)
 
 #### Memory usage tuning
 # If small memory footprint is required, you can reduce the buffer size. There
@@ -174,8 +214,8 @@
 #### Debug settings
 # You can enable debugging on specific code parts by setting DEBUG=-DDEBUG_xxx.
 # Currently defined DEBUG macros include DEBUG_FULL, DEBUG_MEMORY, DEBUG_FSM,
-# DEBUG_HASH, DEBUG_AUTH, DEBUG_SPOE, DEBUG_UAF and DEBUG_THREAD. Please check
-# sources for exact meaning or do not use at all.
+# DEBUG_HASH, DEBUG_AUTH, DEBUG_SPOE, DEBUG_UAF and DEBUG_THREAD, DEBUG_STRICT,
+# DEBUG_DEV. Please check sources for exact meaning or do not use at all.
 DEBUG =
 
 #### Trace options
@@ -194,46 +234,3 @@
 # not want to pollute the report with complex defines.
 # The following settings might be of interest when SSL is enabled :
 #   LISTEN_DEFAULT_CIPHERS is a cipher suite string used to set the default SSL
-#           ciphers on "bind" lines instead of using OpenSSL's defaults.
-#   CONNECT_DEFAULT_CIPHERS is a cipher suite string used to set the default
-#           SSL ciphers on "server" lines instead of using OpenSSL's defaults.
-DEFINE =
-SILENT_DEFINE =
-
-#### extra programs to build
-# Force this to enable building extra programs or to disable them.
-# It's automatically appended depending on the targets.
-EXTRA =
-
-#### CPU dependant optimizations
-# Some CFLAGS are set by default depending on the target CPU. Those flags only
-# feed CPU_CFLAGS, which in turn feed CFLAGS, so it is not mandatory to use
-# them. You should not have to change these options. Better use CPU_CFLAGS or
-# even CFLAGS instead.
-CPU_CFLAGS.generic    = -O2
-CPU_CFLAGS.native     = -O2 -march=native
-CPU_CFLAGS.i586       = -O2 -march=i586
-CPU_CFLAGS.i686       = -O2 -march=i686
-CPU_CFLAGS.ultrasparc = -O6 -mcpu=v9 -mtune=ultrasparc
-CPU_CFLAGS            = $(CPU_CFLAGS.$(CPU))
-
-#### ARCH dependant flags, may be overriden by CPU flags
-ARCH_FLAGS.32     = -m32
-ARCH_FLAGS.64     = -m64
-ARCH_FLAGS.i386   = -m32 -march=i386
-ARCH_FLAGS.i486   = -m32 -march=i486
-ARCH_FLAGS.i586   = -m32 -march=i586
-ARCH_FLAGS.i686   = -m32 -march=i686
-ARCH_FLAGS.x86_64 = -m64 -march=x86-64
-ARCH_FLAGS        = $(ARCH_FLAGS.$(ARCH))
-
-#### Common CFLAGS
-# These CFLAGS contain general optimization options, CPU-specific optimizations
-# and debug flags. They may be overridden by some distributions which prefer to
-# set all of them at once instead of playing with the CPU and DEBUG variables.
-CFLAGS = $(ARCH_FLAGS) $(CPU_CFLAGS) $(DEBUG_CFLAGS) $(SPEC_CFLAGS)
-
-#### Common LDFLAGS
-# These LDFLAGS are used as the first "ld" options, regardless of any library
-# path or any other option. They may be changed to add any linker-specific
-# option at the beginning of the ld command line.

=== debian/changelog ===
haproxy (2.0.5-1ubuntu0.4) eoan-security; urgency=medium

  * SECURITY UPDATE: Arbitrary memory write
    - debian/patches/CVE-2020-11100.patch: make sure the headroom is
      considered only when the buffer does not wrap in src/hpack-tbl.c.
    - CVE-2020-11100

 -- Leonidas S. Barbosa <leo.barbosa@canonical.com>  Fri, 03 Apr 2020 16:36:11 -0300

haproxy (2.0.5-1ubuntu0.3) eoan-security; urgency=medium

  * SECURITY UPDATE: Intermediary Encapsulation attacks
    - debian/patches/CVE-2019-19330-*.patch: reject header values containing
      invalid chars and make header field name filtering stronger in
      src/h2.c, include/common/ist.h.
    - CVE-2019-19330

 -- Leonidas S. Barbosa <leo.barbosa@canonical.com>  Mon, 02 Dec 2019 16:12:00 -0300

haproxy (2.0.5-1ubuntu0.2) eoan-security; urgency=medium

  * SECURITY UPDATE: Messages with transfer-encoding header missing "chunked"
    value were not being correctly rejected
    - debian/patches/CVE-2019-18277.patch: also reject messages where
      "chunked" is missing from transfer-enoding in.
      src/proto_http.c.
    - CVE-2019-18277

 -- Leonidas S. Barbosa <leo.barbosa@canonical.com>  Mon, 04 Nov 2019 11:07:29 -0300

haproxy (2.0.5-1ubuntu0.1) eoan; urgency=medium

  * Fix configurability of dh_params that regressed since building
    against openssl 1.1.1 (LP: #1841936)
    - d/p/lp-1841936-BUG-MEDIUM-ssl-tune.ssl.default-dh-param-value-ignor.patch
    - d/p/lp-1841936-CLEANUP-ssl-make-ssl_sock_load_dh_params-handle-errc.patch

 -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Wed, 23 Oct 2019 12:58:09 +0200

haproxy (2.0.5-1) unstable; urgency=medium

  * New upstream release.
    - BUG/MEDIUM: mux_h1: Don't bother subscribing in recv if we're not
                  connected.
    - BUG/MEDIUM: mux_pt: Don't call unsubscribe if we did not subscribe.
    - BUG/MEDIUM: proxy: Don't forget the SF_HTX flag when upgrading
                  TCP=>H1+HTX.
    - BUG/MEDIUM: proxy: Don't use cs_destroy() when freeing the
                  conn_stream.
    - BUG/MEDIUM: stick-table: Wrong stick-table backends parsing.

 -- Vincent Bernat <bernat@debian.org>  Fri, 16 Aug 2019 19:51:24 +0200

haproxy (2.0.4-1) unstable; urgency=medium

  * New upstream release. Upload to unstable.
    - BUG/MAJOR: http/sample: use a static buffer for raw -> htx
                 conversion
    - BUG/MAJOR: queue/threads: avoid an AB/BA locking issue in
                 process_srv_queue()
  * d/haproxy.cfg: update default cipher lists to more secure defaults.
    TLSv1.0 and TLSv1.1 are disabled, as well as TLS tickets (they are
    breaking forward secrecy unless correctly rotated).
    Closes: #932763.

 -- Vincent Bernat <bernat@debian.org>  Fri, 09 Aug 2019 14:22:23 +0200

haproxy (2.0.3-1) experimental; urgency=medium

  * New upstream version.
    - BUG/CRITICAL: http_ana: Fix parsing of malformed cookies which start by
                    a delimiter (CVE-2019-14241)
    - BUG/MEDIUM: checks: Don't attempt to receive data if we already
                  subscribed.
    - BUG/MEDIUM: http/htx: unbreak option http_proxy
    - DOC: htx: Update comments in HTX files
    - BUG/MEDIUM: mux-h1: Trim excess server data at the end of a transaction
    - BUG/MEDIUM: tcp-checks: do not dereference inexisting conn_stream
  * Bump Standards-Version to 4.4.0; no changes needed

 -- Apollon Oikonomopoulos <apoikos@debian.org>  Tue, 23 Jul 2019 13:31:31 -0300

haproxy (2.0.2-1) experimental; urgency=medium

  * New upstream version.
    - BUG/MAJOR: listener: fix thread safety in resume_listener()

 -- Vincent Bernat <bernat@debian.org>  Wed, 17 Jul 2019 12:19:54 +0200

haproxy (2.0.1-1) experimental; urgency=medium

  * New upstream version.
    - BUG/MAJOR: sample: Wrong stick-table name parsing in "if/unless" ACL
                 condition.
    - BUG/MAJOR: mux-h1: Don't crush trash chunk area when outgoing
                 message is formatted
  * d/rules: fix crash during reload due to libgcc_s.so missing when
    chrooted.

 -- Vincent Bernat <bernat@debian.org>  Mon, 24 Jun 2019 19:28:26 +0200

haproxy (2.0.0-1) experimental; urgency=medium

  * New upstream version.
  * d/watch: update to follow 2.0.
  * d/gbp.conf: update for 2.0 and experimental.
  * d/rules: update to use linux-glibc target.
  * d/rules: enable prometheus exporter.
  * d/patches: refresh patches.
  * d/vim-haproxy.install: update path to vim syntax file.
  * d/README.Debian: remove outdated information.

 -- Vincent Bernat <bernat@debian.org>  Thu, 20 Jun 2019 11:40:19 +0200

haproxy (1.9.8-1) experimental; urgency=medium

  * New upstream version.
    - BUG/MAJOR: map/acl: real fix segfault during show map/acl on CLI
    - BUG/MAJOR: mux-h2: do not add a stream twice to the send list

 -- Vincent Bernat <bernat@debian.org>  Thu, 16 May 2019 01:50:10 +0200

haproxy (1.9.7-1) experimental; urgency=medium

  * New upstream version.
    - BUG/MAJOR: http_fetch: Get the channel depending on the keyword used
    - BUG/MAJOR: lb/threads: fix AB/BA locking issue in round-robin LB
    - BUG/MAJOR: lb/threads: fix insufficient locking on round-robin LB
    - BUG/MAJOR: muxes: Use the HTX mode to find the best mux for HTTP
                 proxies only
    - BUG/MAJOR: task: make sure never to delete a queued task

 -- Vincent Bernat <bernat@debian.org>  Sun, 28 Apr 2019 17:37:04 +0200

haproxy (1.9.6-1) experimental; urgency=medium

  * New upstream version.
    - BUG/MAJOR: checks: segfault during tcpcheck_main

 -- Vincent Bernat <bernat@debian.org>  Sat, 30 Mar 2019 12:43:33 +0100

haproxy (1.9.5-1) experimental; urgency=medium

  * New upstream version.
    - BUG/MAJOR: cache/htx: Set the start-line offset when a cached object
                 is served
    - BUG/MAJOR: fd/threads, task/threads: ensure all spin locks are
                 unlocked
    - BUG/MAJOR: listener: Make sure the listener exist before using it.
    - BUG/MAJOR: mux-h2: fix race condition between close on both ends


=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 Uploaders: Apollon Oikonomopoulos <apoikos@debian.org>,
            Prach Pongpanich <prach@debian.org>,
            Vincent Bernat <bernat@debian.org>
-Standards-Version: 4.3.0
+Standards-Version: 4.4.0
 Build-Depends: debhelper (>= 10),
                libpcre2-dev,
                libssl-dev,

## haproxy 2.0.6

=== debian/changelog ===
haproxy (2.0.6-2~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Vincent Bernat <bernat@debian.org>  Wed, 18 Sep 2019 08:10:21 +0200

haproxy (2.0.6-2) unstable; urgency=medium

  * d/patches: fix regression with checks.

 -- Vincent Bernat <bernat@debian.org>  Wed, 18 Sep 2019 08:02:53 +0200

haproxy (2.0.6-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Vincent Bernat <bernat@debian.org>  Sat, 14 Sep 2019 10:50:41 +0200

haproxy (2.0.6-1) unstable; urgency=medium

  * New upstream release.
    - BUG/MAJOR: ssl: ssl_sock was not fully initialized.

 -- Vincent Bernat <bernat@debian.org>  Fri, 13 Sep 2019 21:25:38 +0200

haproxy (2.0.5-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Vincent Bernat <bernat@debian.org>  Thu, 22 Aug 2019 10:54:27 +0200

haproxy (2.0.4-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Vincent Bernat <bernat@debian.org>  Fri, 09 Aug 2019 14:34:56 +0200

haproxy (2.0.3-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Vincent Bernat <bernat@debian.org>  Tue, 23 Jul 2019 19:04:47 +0200

haproxy (2.0.2-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Vincent Bernat <bernat@debian.org>  Wed, 17 Jul 2019 15:55:25 +0200

haproxy (2.0.1-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Vincent Bernat <bernat@debian.org>  Sat, 29 Jun 2019 08:21:44 +0200

## haproxy 2.0.9

=== debian/changelog ===
haproxy (2.0.9-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Vincent Bernat <bernat@debian.org>  Sun, 17 Nov 2019 14:24:23 +0100

haproxy (2.0.9-1) unstable; urgency=medium

  * New upstream release.
    - BUG/MAJOR: stream-int: Don't receive data from mux until SI_ST_EST
                 is reached

 -- Vincent Bernat <bernat@debian.org>  Sat, 16 Nov 2019 17:38:51 +0100

haproxy (2.0.8-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Vincent Bernat <bernat@debian.org>  Fri, 25 Oct 2019 09:23:19 +0200

haproxy (2.0.8-1) unstable; urgency=medium

  * New upstream release.
    - BUG/MAJOR: idle conns: schedule the cleanup task on the correct
                 threads

 -- Vincent Bernat <bernat@debian.org>  Wed, 23 Oct 2019 08:55:55 +0200

haproxy (2.0.7-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Vincent Bernat <bernat@debian.org>  Sat, 28 Sep 2019 20:07:44 +0200

haproxy (2.0.7-1) unstable; urgency=medium

  * New upstream release.  
    - BUG/MAJOR: mux-h2: Handle HEADERS frames received after a RST_STREAM
                 frame
    - BUG/MAJOR: mux_h2: Don't consume more payload than received for
                 skipped frames
    - BUG/MEDIUM: checks: make sure the connection is ready before trying
                  to recv

 -- Vincent Bernat <bernat@debian.org>  Fri, 27 Sep 2019 19:14:12 +0200

## haproxy 2.0.10

=== debian/changelog ===
haproxy (2.0.10-1~bpo10+1) buster-backports; urgency=high

  * Rebuild for buster-backports.

 -- Vincent Bernat <bernat@debian.org>  Tue, 26 Nov 2019 13:30:11 +0100

haproxy (2.0.10-1) unstable; urgency=medium

  * New upstream release.
    - BUG/MAJOR: h2: make header field name filtering stronger
    - BUG/MAJOR: h2: reject header values containing invalid chars
    - BUG/MAJOR: mux-h2: don't try to decode a response HEADERS frame in
                 idle state

 -- Vincent Bernat <bernat@debian.org>  Tue, 26 Nov 2019 13:22:17 +0100

=== debian/rules ===
--- 
+++ 
@@ -4,9 +4,7 @@
 include /usr/share/dpkg/architecture.mk
 include /usr/share/dpkg/buildflags.mk
 
-ifneq ($(shell dpkg-architecture -qDEB_BUILD_ARCH), sw_64)
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
-endif
 export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
 MAKEARGS=DESTDIR=debian/haproxy \
@@ -19,11 +17,11 @@
 	 USE_OPENSSL=1 \
 	 USE_ZLIB=1 \
 	 USE_LUA=1 \
-	 USE_GETADDRINFO=1 \
-	 LUA_INC=/usr/include/lua5.3
+	 LUA_INC=/usr/include/lua5.3 \
+	 EXTRA_OBJS="contrib/prometheus-exporter/service-prometheus.o"
 
 ifeq ($(DEB_HOST_ARCH_OS),linux)
-        MAKEARGS+= USE_NS=1 TARGET=linux2628 USE_SYSTEMD=1
+        MAKEARGS+= TARGET=linux-glibc USE_SYSTEMD=1
 else ifeq ($(DEB_HOST_ARCH_OS),kfreebsd)
         MAKEARGS+= TARGET=freebsd
 else
@@ -35,7 +33,9 @@
 endif
 
 ifneq ($(filter armel mips mipsel m68k powerpc powerpcspe sh4,$(DEB_HOST_ARCH)),)
-	MAKEARGS+= ADDLIB=-latomic
+	MAKEARGS+= ADDLIB="-latomic -Wl,--no-as-needed -lgcc_s -Wl,--as-needed"
+else
+	MAKEARGS+= ADDLIB="-Wl,--no-as-needed -lgcc_s -Wl,--as-needed"
 endif
 
 MAKEARGS += DEBUG_CFLAGS="$(CFLAGS) $(CPPFLAGS)"

## haproxy 2.0.12

=== Makefile ===
--- 
+++ 
@@ -182,7 +182,6 @@
 # to be sure we get the intended behavior.
 SPEC_CFLAGS := -fno-strict-aliasing -Wdeclaration-after-statement
 SPEC_CFLAGS += $(call cc-opt-alt,-fwrapv,$(call cc-opt,-fno-strict-overflow))
-SPEC_CFLAGS += $(call cc-nowarn,format-truncation)
 SPEC_CFLAGS += $(call cc-nowarn,address-of-packed-member)
 SPEC_CFLAGS += $(call cc-nowarn,unused-label)
 SPEC_CFLAGS += $(call cc-nowarn,sign-compare)
@@ -234,3 +233,4 @@
 # not want to pollute the report with complex defines.
 # The following settings might be of interest when SSL is enabled :
 #   LISTEN_DEFAULT_CIPHERS is a cipher suite string used to set the default SSL
+#           ciphers on "bind" lines instead of using OpenSSL's defaults.

=== debian/changelog ===
haproxy (2.0.12-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Vincent Bernat <bernat@debian.org>  Sat, 21 Dec 2019 18:38:28 +0100

haproxy (2.0.12-1) unstable; urgency=medium

  * New upstream version.
    - BUG/MAJOR: task: add a new TASK_SHARED_WQ flag to fix foreign requeuing
  * d/logrotate.conf: use rsyslog helper instead of SysV init script.
    Closes: #946973.

 -- Vincent Bernat <bernat@debian.org>  Fri, 20 Dec 2019 08:20:33 +0100

haproxy (2.0.11-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Vincent Bernat <bernat@debian.org>  Sat, 14 Dec 2019 11:12:00 +0100

haproxy (2.0.11-1) unstable; urgency=medium

  * New upstream release.
    - BUG/MAJOR: dns: add minimalist error processing on the Rx path

 -- Vincent Bernat <bernat@debian.org>  Fri, 13 Dec 2019 19:22:03 +0100

## haproxy 2.0.13

=== Makefile ===
--- 
+++ 
@@ -141,8 +141,8 @@
 #### TARGET system
 # Use TARGET=<target_name> to optimize for a specifc target OS among the
 # following list (use the default "generic" if uncertain) :
-#    linux-glibc, solaris, freebsd, openbsd, netbsd, cygwin,
-#    haiku, aix51, aix52, osx, generic, custom
+#    linux-glibc, linux-glibc-legacy, solaris, freebsd, openbsd, netbsd,
+#    cygwin, haiku, aix51, aix52, osx, generic, custom
 TARGET =
 
 #### TARGET CPU
@@ -233,4 +233,3 @@
 # not want to pollute the report with complex defines.
 # The following settings might be of interest when SSL is enabled :
 #   LISTEN_DEFAULT_CIPHERS is a cipher suite string used to set the default SSL
-#           ciphers on "bind" lines instead of using OpenSSL's defaults.

=== debian/changelog ===
haproxy (2.0.13-2) unstable; urgency=medium

  * d/dconv: replace cgi.escape by html.escape. Closes: #951416.
  * d/copryight: document OpenSSL exception. Closes: #951782.
  * d/haproxy.cfg: use "ssl-min-ver" to set minimum version.
  * Apply one patch to fix an overflow in HTTP/2 header handling.
    Fix CVE-2020-11100.

 -- Vincent Bernat <bernat@debian.org>  Wed, 01 Apr 2020 21:49:32 +0200

haproxy (2.0.13-1) unstable; urgency=medium

  * New upstream release.
    - BUG/MAJOR: hashes: fix the signedness of the hash inputs
    - BUG/MAJOR: memory: Don't forget to unlock the rwlock if the pool is
                 empty.
  * d/dconv: use Python 3 to build the documentation.
    Closes: #948296, #950435.

 -- Vincent Bernat <bernat@debian.org>  Sat, 15 Feb 2020 15:32:32 +0100

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: haproxy
 Section: net
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian HAProxy Maintainers <haproxy@tracker.debian.org>
+Maintainer: Debian HAProxy Maintainers <haproxy@tracker.debian.org>
 Uploaders: Apollon Oikonomopoulos <apoikos@debian.org>,
            Prach Pongpanich <prach@debian.org>,
            Vincent Bernat <bernat@debian.org>
@@ -14,7 +13,7 @@
                libsystemd-dev [linux-any],
                python3-sphinx,
                zlib1g-dev
-Build-Depends-Indep: python, python-mako
+Build-Depends-Indep: python3, python3-mako
 Homepage: http://www.haproxy.org/
 Vcs-Git: https://salsa.debian.org/haproxy-team/haproxy.git
 Vcs-Browser: https://salsa.debian.org/haproxy-team/haproxy

=== debian/rules ===
--- 
+++ 
@@ -59,7 +59,7 @@
 	# Build the HTML documentation, after patching dconv
 	patch -p1 < $(CURDIR)/debian/patches/debianize-dconv.patch
 	for doc in intro configuration management; do \
-		python -B $(CURDIR)/debian/dconv/haproxy-dconv.py \
+		python3 -B $(CURDIR)/debian/dconv/haproxy-dconv.py \
 			-i $(CURDIR)/doc/$${doc}.txt \
 			-o $(CURDIR)/doc/$${doc}.html ;\
 	done

=== debian/watch ===
version=3
opts="uversionmangle=s/-(dev\d+)/~$1/" https://www.haproxy.org/download/2.0/src/ haproxy-(2\.0(?:\.|-dev)\d+)\.(?:tgz|tbz2|tar\.(?:gz|bz2|xz))

## haproxy 2.0.14

=== debian/changelog ===
haproxy (2.0.14-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Vincent Bernat <bernat@debian.org>  Thu, 16 Apr 2020 18:47:06 +0200

haproxy (2.0.14-1) unstable; urgency=medium

  * New upstream release.
    - BUG/CRITICAL: hpack: never index a header into the headroom after
                    wrapping
    - BUG/MAJOR: http-ana: Always abort the request when a tarpit is
                 triggered
    - BUG/MAJOR: list: fix invalid element address calculation
    - BUG/MAJOR: proxy_protocol: Properly validate TLV lengths
  * d/control: fix maintainer address. Closes: #955553.

 -- Vincent Bernat <bernat@debian.org>  Thu, 16 Apr 2020 18:34:22 +0200

haproxy (2.0.13-2~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Vincent Bernat <bernat@debian.org>  Thu, 02 Apr 2020 11:46:07 +0200

haproxy (2.0.13-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Vincent Bernat <bernat@debian.org>  Sat, 15 Feb 2020 17:38:56 +0100

## haproxy 2.0.15

=== debian/changelog ===
haproxy (2.0.15-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Vincent Bernat <bernat@debian.org>  Sun, 14 Jun 2020 18:39:04 +0200

haproxy (2.0.15-1) unstable; urgency=medium

  * New upstream release.
    - BUG/MAJOR: stream-int: always detach a faulty endpoint on connect
                 failure

 -- Vincent Bernat <bernat@debian.org>  Sat, 13 Jun 2020 18:48:25 +0200
